# coding: utf-8

"""
    ChRIS Research Integration System: Ultron BackEnd (CUBE) API

    The ChRIS Ultron BackEnd (CUBE) is the core backend API of ChRIS. It manages ChRIS users, plugins, pipelines, and the provenance of data analyses as ChRIS feeds.

    The version of the OpenAPI document: ${GITHUB_REF_NAME:1}
    Contact: dev@babymri.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class ComputeResourceRequest(BaseModel):
    """
    ComputeResourceRequest
    """ # noqa: E501
    name: Annotated[str, Field(min_length=1, strict=True, max_length=100)]
    compute_url: Annotated[str, Field(min_length=1, strict=True, max_length=300)]
    compute_auth_url: Optional[Annotated[str, Field(strict=True, max_length=350)]] = None
    compute_innetwork: Optional[StrictBool] = None
    compute_user: Annotated[str, Field(min_length=4, strict=True, max_length=32)]
    compute_password: Annotated[str, Field(min_length=8, strict=True, max_length=100)]
    compute_auth_token: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=500)]] = None
    description: Optional[Annotated[str, Field(strict=True, max_length=600)]] = None
    max_job_exec_seconds: Optional[Annotated[int, Field(le=2147483647, strict=True, ge=-2147483648)]] = None
    __properties: ClassVar[List[str]] = ["name", "compute_url", "compute_auth_url", "compute_innetwork", "compute_user", "compute_password", "compute_auth_token", "description", "max_job_exec_seconds"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ComputeResourceRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ComputeResourceRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "compute_url": obj.get("compute_url"),
            "compute_auth_url": obj.get("compute_auth_url"),
            "compute_innetwork": obj.get("compute_innetwork"),
            "compute_user": obj.get("compute_user"),
            "compute_password": obj.get("compute_password"),
            "compute_auth_token": obj.get("compute_auth_token"),
            "description": obj.get("description"),
            "max_job_exec_seconds": obj.get("max_job_exec_seconds")
        })
        return _obj


