# coding: utf-8

"""
    ChRIS Research Integration System: Ultron BackEnd (CUBE) API

    The ChRIS Ultron BackEnd (CUBE) is the core backend API of ChRIS. It manages ChRIS users, plugins, pipelines, and the provenance of data analyses as ChRIS feeds.

    The version of the OpenAPI document: ${GITHUB_REF_NAME:1}
    Contact: dev@babymri.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date, datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from aiochris_oag.models.pacs_series_patient_sex import PACSSeriesPatientSex
from typing import Optional, Set
from typing_extensions import Self

class PACSSeries(BaseModel):
    """
    PACSSeries
    """ # noqa: E501
    url: StrictStr
    id: StrictInt
    creation_date: datetime
    patient_id: Annotated[str, Field(strict=True, max_length=100)] = Field(alias="PatientID")
    patient_name: Optional[Annotated[str, Field(strict=True, max_length=150)]] = Field(default=None, alias="PatientName")
    patient_birth_date: Optional[date] = Field(default=None, alias="PatientBirthDate")
    patient_age: Optional[Annotated[int, Field(le=2147483647, strict=True, ge=-2147483648)]] = Field(default=None, alias="PatientAge")
    patient_sex: Optional[PACSSeriesPatientSex] = Field(default=None, alias="PatientSex")
    study_date: date = Field(alias="StudyDate")
    accession_number: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, alias="AccessionNumber")
    modality: Optional[Annotated[str, Field(strict=True, max_length=15)]] = Field(default=None, alias="Modality")
    protocol_name: Optional[Annotated[str, Field(strict=True, max_length=64)]] = Field(default=None, alias="ProtocolName")
    study_instance_uid: Annotated[str, Field(strict=True, max_length=100)] = Field(alias="StudyInstanceUID")
    study_description: Optional[Annotated[str, Field(strict=True, max_length=400)]] = Field(default=None, alias="StudyDescription")
    series_instance_uid: Annotated[str, Field(strict=True, max_length=100)] = Field(alias="SeriesInstanceUID")
    series_description: Optional[Annotated[str, Field(strict=True, max_length=400)]] = Field(default=None, alias="SeriesDescription")
    pacs_identifier: StrictStr
    folder: StrictStr
    __properties: ClassVar[List[str]] = ["url", "id", "creation_date", "PatientID", "PatientName", "PatientBirthDate", "PatientAge", "PatientSex", "StudyDate", "AccessionNumber", "Modality", "ProtocolName", "StudyInstanceUID", "StudyDescription", "SeriesInstanceUID", "SeriesDescription", "pacs_identifier", "folder"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PACSSeries from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "url",
            "id",
            "creation_date",
            "pacs_identifier",
            "folder",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of patient_sex
        if self.patient_sex:
            _dict['PatientSex'] = self.patient_sex.to_dict()
        # set to None if patient_birth_date (nullable) is None
        # and model_fields_set contains the field
        if self.patient_birth_date is None and "patient_birth_date" in self.model_fields_set:
            _dict['PatientBirthDate'] = None

        # set to None if patient_age (nullable) is None
        # and model_fields_set contains the field
        if self.patient_age is None and "patient_age" in self.model_fields_set:
            _dict['PatientAge'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PACSSeries from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "url": obj.get("url"),
            "id": obj.get("id"),
            "creation_date": obj.get("creation_date"),
            "PatientID": obj.get("PatientID"),
            "PatientName": obj.get("PatientName"),
            "PatientBirthDate": obj.get("PatientBirthDate"),
            "PatientAge": obj.get("PatientAge"),
            "PatientSex": PACSSeriesPatientSex.from_dict(obj["PatientSex"]) if obj.get("PatientSex") is not None else None,
            "StudyDate": obj.get("StudyDate"),
            "AccessionNumber": obj.get("AccessionNumber"),
            "Modality": obj.get("Modality"),
            "ProtocolName": obj.get("ProtocolName"),
            "StudyInstanceUID": obj.get("StudyInstanceUID"),
            "StudyDescription": obj.get("StudyDescription"),
            "SeriesInstanceUID": obj.get("SeriesInstanceUID"),
            "SeriesDescription": obj.get("SeriesDescription"),
            "pacs_identifier": obj.get("pacs_identifier"),
            "folder": obj.get("folder")
        })
        return _obj


