# coding: utf-8

"""
    ChRIS Research Integration System: Ultron BackEnd (CUBE) API

    The ChRIS Ultron BackEnd (CUBE) is the core backend API of ChRIS. It manages ChRIS users, plugins, pipelines, and the provenance of data analyses as ChRIS feeds.

    The version of the OpenAPI document: ${GITHUB_REF_NAME:1}
    Contact: dev@babymri.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from aiochris_oag.models.plugin_type import PluginType
from typing import Optional, Set
from typing_extensions import Self

class PluginMeta(BaseModel):
    """
    PluginMeta
    """ # noqa: E501
    url: StrictStr
    id: StrictInt
    creation_date: datetime
    modification_date: datetime
    name: Annotated[str, Field(strict=True, max_length=100)]
    title: Optional[Annotated[str, Field(strict=True, max_length=400)]] = None
    stars: Optional[Annotated[int, Field(le=2147483647, strict=True, ge=-2147483648)]] = None
    public_repo: Optional[Annotated[str, Field(strict=True, max_length=300)]] = None
    license: Optional[Annotated[str, Field(strict=True, max_length=50)]] = None
    type: Optional[PluginType] = None
    icon: Optional[Annotated[str, Field(strict=True, max_length=300)]] = None
    category: Optional[Annotated[str, Field(strict=True, max_length=100)]] = None
    authors: Optional[Annotated[str, Field(strict=True, max_length=200)]] = None
    documentation: Optional[Annotated[str, Field(strict=True, max_length=800)]] = None
    plugins: StrictStr
    __properties: ClassVar[List[str]] = ["url", "id", "creation_date", "modification_date", "name", "title", "stars", "public_repo", "license", "type", "icon", "category", "authors", "documentation", "plugins"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PluginMeta from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "url",
            "id",
            "creation_date",
            "modification_date",
            "plugins",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PluginMeta from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "url": obj.get("url"),
            "id": obj.get("id"),
            "creation_date": obj.get("creation_date"),
            "modification_date": obj.get("modification_date"),
            "name": obj.get("name"),
            "title": obj.get("title"),
            "stars": obj.get("stars"),
            "public_repo": obj.get("public_repo"),
            "license": obj.get("license"),
            "type": obj.get("type"),
            "icon": obj.get("icon"),
            "category": obj.get("category"),
            "authors": obj.get("authors"),
            "documentation": obj.get("documentation"),
            "plugins": obj.get("plugins")
        })
        return _obj


