# coding: utf-8

"""
    ChRIS Research Integration System: Ultron BackEnd (CUBE) API

    The ChRIS Ultron BackEnd (CUBE) is the core backend API of ChRIS. It manages ChRIS users, plugins, pipelines, and the provenance of data analyses as ChRIS feeds.

    The version of the OpenAPI document: ${GITHUB_REF_NAME:1}
    Contact: dev@babymri.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from aiochris_oag.models.plugin_parameter_default import PluginParameterDefault
from aiochris_oag.models.plugin_parameter_type import PluginParameterType
from typing import Optional, Set
from typing_extensions import Self

class PluginParameter(BaseModel):
    """
    PluginParameter
    """ # noqa: E501
    url: StrictStr
    id: StrictInt
    name: Annotated[str, Field(strict=True, max_length=50)]
    type: Optional[PluginParameterType] = None
    optional: Optional[StrictBool] = None
    default: Optional[PluginParameterDefault]
    flag: Annotated[str, Field(strict=True, max_length=52)]
    short_flag: Optional[Annotated[str, Field(strict=True, max_length=52)]] = None
    action: Optional[Annotated[str, Field(strict=True, max_length=20)]] = None
    help: Optional[StrictStr] = None
    ui_exposed: Optional[StrictBool] = None
    plugin: StrictStr
    __properties: ClassVar[List[str]] = ["url", "id", "name", "type", "optional", "default", "flag", "short_flag", "action", "help", "ui_exposed", "plugin"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PluginParameter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "url",
            "id",
            "plugin",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of default
        if self.default:
            _dict['default'] = self.default.to_dict()
        # set to None if default (nullable) is None
        # and model_fields_set contains the field
        if self.default is None and "default" in self.model_fields_set:
            _dict['default'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PluginParameter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "url": obj.get("url"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "type": obj.get("type"),
            "optional": obj.get("optional"),
            "default": PluginParameterDefault.from_dict(obj["default"]) if obj.get("default") is not None else None,
            "flag": obj.get("flag"),
            "short_flag": obj.get("short_flag"),
            "action": obj.get("action"),
            "help": obj.get("help"),
            "ui_exposed": obj.get("ui_exposed"),
            "plugin": obj.get("plugin")
        })
        return _obj


