# coding: utf-8

"""
    ChRIS Research Integration System: Ultron BackEnd (CUBE) API

    The ChRIS Ultron BackEnd (CUBE) is the core backend API of ChRIS. It manages ChRIS users, plugins, pipelines, and the provenance of data analyses as ChRIS feeds.

    The version of the OpenAPI document: ${GITHUB_REF_NAME:1}
    Contact: dev@babymri.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class Workflow(BaseModel):
    """
    Workflow
    """ # noqa: E501
    url: StrictStr
    id: StrictInt
    creation_date: datetime
    title: Optional[Annotated[str, Field(strict=True, max_length=100)]] = None
    pipeline_id: StrictInt
    pipeline_name: StrictStr
    owner_username: StrictStr = Field(description="Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only.")
    created_jobs: StrictInt = Field(description="Overriden to get the number of plugin instances in 'created' status.")
    waiting_jobs: StrictInt = Field(description="Overriden to get the number of plugin instances in 'waiting' status.")
    scheduled_jobs: StrictInt = Field(description="Overriden to get the number of plugin instances in 'scheduled' status.")
    started_jobs: StrictInt = Field(description="Overriden to get the number of plugin instances in 'started' status.")
    registering_jobs: StrictInt = Field(description="Overriden to get the number of plugin instances in 'registeringFiles' status.")
    finished_jobs: StrictInt = Field(description="Overriden to get the number of plugin instances in 'finishedSuccessfully' status.")
    errored_jobs: StrictInt = Field(description="Overriden to get the number of plugin instances in 'finishedWithError' status.")
    cancelled_jobs: StrictInt = Field(description="Overriden to get the number of plugin instances in 'cancelled' status.")
    pipeline: StrictStr
    plugin_instances: StrictStr
    __properties: ClassVar[List[str]] = ["url", "id", "creation_date", "title", "pipeline_id", "pipeline_name", "owner_username", "created_jobs", "waiting_jobs", "scheduled_jobs", "started_jobs", "registering_jobs", "finished_jobs", "errored_jobs", "cancelled_jobs", "pipeline", "plugin_instances"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Workflow from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "url",
            "id",
            "creation_date",
            "pipeline_id",
            "pipeline_name",
            "owner_username",
            "created_jobs",
            "waiting_jobs",
            "scheduled_jobs",
            "started_jobs",
            "registering_jobs",
            "finished_jobs",
            "errored_jobs",
            "cancelled_jobs",
            "pipeline",
            "plugin_instances",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Workflow from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "url": obj.get("url"),
            "id": obj.get("id"),
            "creation_date": obj.get("creation_date"),
            "title": obj.get("title"),
            "pipeline_id": obj.get("pipeline_id"),
            "pipeline_name": obj.get("pipeline_name"),
            "owner_username": obj.get("owner_username"),
            "created_jobs": obj.get("created_jobs"),
            "waiting_jobs": obj.get("waiting_jobs"),
            "scheduled_jobs": obj.get("scheduled_jobs"),
            "started_jobs": obj.get("started_jobs"),
            "registering_jobs": obj.get("registering_jobs"),
            "finished_jobs": obj.get("finished_jobs"),
            "errored_jobs": obj.get("errored_jobs"),
            "cancelled_jobs": obj.get("cancelled_jobs"),
            "pipeline": obj.get("pipeline"),
            "plugin_instances": obj.get("plugin_instances")
        })
        return _obj


